﻿// 2011, Omer Faruk ZORLU
// http://www.omerfarukzorlu.com
using System;
using System.Data.SqlClient;
using OMR.DataSync.Core.Helpers;

namespace OMR.TableDataSync.Core.DataAccess.Core
{
    // OMR
    public sealed class SqlParameterHelper
    {
        private int _parameterIndex = 0;
        private SqlParameter[] _parameterList { get; set; }

        public SqlParameterHelper(int length)
        {
            _parameterList = new SqlParameter[length];
        }

        public void Add(string name, object value)
        {
            ValidationHelper.AreNotNull(name);

            _parameterList[_parameterIndex++] = new SqlParameter(name, value);
        }

        public void Add(SqlParameter[] sqlParameters)
        {
            ValidationHelper.AreNotNull(sqlParameters);

            foreach (var parameter in sqlParameters)
            {
                _parameterList[_parameterIndex++] = parameter;
            }
        }

        public SqlParameter[] ToArray()
        {
            return _parameterList;
        }

        // TODO: overload Add methods

        public void Clear()
        {
            Array.Clear(_parameterList, 0, _parameterList.Length);
        }
    }
}
